## 操作说明

进入配置文件项目(`cd vcooline_ikcrm_config; git checkout ding`)，执行如下命令：
```bash
ruby -e "`curl http://gitlab.ikcrm.com/ikcrm_common/servers_config/raw/master/setup.rb`" prod
```

### 说明
1. 项目配置文件名称(`vcooline_ikcrm_config`)去掉 `_config` 后需匹配该项目的1级子目录名称。
1. 项目配置文件(`vcooline_ikcrm_config`)的分支名称(`ding`分支)需匹配该项目的2级子目录名称
1. 上述脚本中的参数 `prod` 为环境名称，需匹配该项目的3级子目录名称

#### 以CRM钉钉版生产环境为例:
  1. 配置文件项目名称为 `vcooline_ikcrm_config`，去掉 `_config` 后对应1级子目录为`vcooline_ikcrm`
  1. 分支为 `ding`，对应2级子目录为 `ding`
  1. 环境名称为 `prod`，对应3级子目录为 `prod`
  1. `server.json` url对应的全路径为： http://gitlab.ikcrm.com/ikcrm_common/servers_config/raw/master/`vcooline_ikcrm`/`ding`/`prod`/server.json



### 各产品线配置文件项目说明(以CRM为例)：

1. 不同平台使用不同分支(独立版: `master` , 钉钉版: `ding` , 励销版: `wx`)，如果只有一个平台，那么只使用 `master` 分支即可。
1. 每个平台都有 `dev` , `test` , `staging` , `prod` 目录，对应不同环境
1. 正常情况下，每个环境的目录(以生产环境`prod`目录为例)下有一个 `app` 目录，`app` 目录里存放原来生产服务器上 `deploy_to/shared/config` 里的配置文件。
1. 生产环境的服务器可能会很多，每台服务器的配置文件可能略有差别。我们在 `capistrano` 里会给每台服务器设定一个或者多个角色(`role`)，如果该角色和 `app` 角色的配置有差异，则需在环境目录(`prod`)下创建一个和该角色(`role`)相同(或者相关，参见： `push_config.sb.erb`中`ROLE_ALIASES`的定义)的目录，该目录下存放和`app`目录的差异化配置文件
1. 比如独立版生产环境要做数据库 `dml` 和 `ddl` 账号分离，那么环境目录(`prod`)下除了有一个 `app` 目录之外，还有一个 `db` 目录，该目录里面只有一个配置了 `ddl` 账号信息的 `database.yml` 文件。
1. 其它情况可参照 `dml` 和 `ddl` 账号分离的做法。


`爱客CRM` 独立版配置文件目录结构示例如下：
```
vcooline_ikcrm_config(master)
├── dev
├── prod
│   ├── app
│   │   ├── services.yml
│   │   ├── cross_sites.yml
│   │   ├── database.yml
│   │   ├── ******
│   ├── db
│   │   ├── database.yml
│   └── slave_app
│       ├── database.yml
│       └── unicorn
│           └── production.rb
├── staging
└── test
```