require 'erb'
require 'json'

class ScriptGenerator
  attr_accessor :product_name, :git_branch, :config_root
  def initialize
    self.config_root = File.expand_path('..', __FILE__)
    self.product_name = File.basename(File.expand_path('..', config_root).gsub("_config", ""))
    self.git_branch = `cd #{config_root}; git rev-parse --abbrev-ref HEAD`.chop
  end

  def download_server_json
    env_name = File.basename config_root
    server_conf_url = "http://gitlab.ikcrm.com/ikcrm_common/servers_config/raw/master/#{product_name}/#{git_branch}/#{env_name}/server.json"
    puts "Use server config url: #{server_conf_url}"
    system "curl #{server_conf_url} > #{config_root}/server.json"
  end

  def deploy_binding
    config_root = File.expand_path('..', __FILE__)
    server_conf = JSON(File.read("#{__dir__}/server.json"))
    binding
  end

  def generate_push_config
    template = ERB.new File.read("#{__dir__}/push_config.sh.erb"), nil, '>'
    script_content = template.result(deploy_binding)
    puts "\n\n\n******************* push_config content *******************\n\n\n"
    puts script_content
    File.open("#{__dir__}/push_config.sh", "w") { |f| f.write(script_content) }
  end

  def generate_pull_config
    template = ERB.new File.read("#{__dir__}/pull_config.sh.erb"), nil, '>'
    script_content = template.result(deploy_binding)
    puts "\n\n\n******************* pull_config content *******************\n\n\n"
    puts script_content
    File.open("#{__dir__}/pull_config.sh", "w") { |f| f.write(script_content) }
  end
end
