#!/usr/bin/env ruby

env_name = ARGV[0] # dev, test, staging, prod
config_root = File.expand_path("../#{env_name}", __FILE__)
if env_name.nil?
  raise "Dir name is required!"
elsif !Dir.exists?(config_root)
  raise "Dir: #{config_root} not exists!"
end

puts "======================= config_root is: #{config_root} ======================="

git_config_url = "http://gitlab.ikcrm.com/ikcrm_common/servers_config/raw/master"
setup_url = "#{git_config_url}/script_generator.rb"
puts "Use script_generator url: #{setup_url}"
system "curl #{setup_url} > #{config_root}/script_generator.rb"

push_script_url = "#{git_config_url}/push_config.sh.erb"
puts "Use push script url: #{push_script_url}"
system "curl #{push_script_url} > #{config_root}/push_config.sh.erb"

pull_script_url = "#{git_config_url}/pull_config.sh.erb"
puts "Use pull script url: #{pull_script_url}"
system "curl #{pull_script_url} > #{config_root}/pull_config.sh.erb"

require "#{config_root}/script_generator.rb"

generator = ScriptGenerator.new
generator.download_server_json
generator.generate_push_config
generator.generate_pull_config

# Usage example:
# `ruby setup_script.rb crm prod` OR ./setup_script.rb crm prod
